
Redmine - Defect #3567

Sorting for changesets might go wrong on Mercurial repos

2009-06-30 23:35 - Ammler _

Status: Closed Start date: 2009-06-30

Priority: Normal Due date:  

Assignee: Toshi MARUYAMA % Done: 100%

Category: SCM Estimated time: 0.00 hour

Target version: 1.1.0   

Resolution: Fixed Affected version:  

Description

The DVCS Mercurial allows to commit changesets with configureable, i.e. with "hg ci -d "2222-10-20...", then the next changeset

could have a earlier date. Of course, ususally it shouldn't happen, but it can, maybe only seconds but it does. :-)

So the sorting depend on revision number for Mercurial, Git doesn't have numbers (in Redmine), so it can't be used as general

setting.

I don't know, if it's a bug or a feature request, feel free to decide that self. ;-)

Examples from 2 repos (the "bad" version is r137):

https://dev.openttdcoop.org/projects/worldairlineset/repository/revisions

http://mz.openttdcoop.org/hg/worldairlineset/shortlog

Related issues:

Related to Redmine - Defect #3449: Redmine Takes Too Long On Large Mercurial ... Closed 2009-06-05

Associated revisions

Revision 4611 - 2011-01-02 07:05 - Toshi MARUYAMA

Fixed: repository: mercurial: sort changesets by revision (#3449, #3567).

In DVCS, changesets are not in date order.

Because Mercurial backend inserts changesets from eariest, 'ORDER BY id'

means 'order by revision number'.

Contributed by Yuya Nishihara.

Revision 5644 - 2011-05-05 01:38 - Toshi MARUYAMA

scm: git: add comments of revision order in fetch_changesets().

Related issues.

#5357, #6013, #7146, #4773, #4547, #1406, #3449, #3567.

History

#1 - 2009-07-01 00:07 - Mischa The Evil

Edited description to prevent unwanted output

#2 - 2009-07-01 13:18 - Ammler _

- File redmine_hg_sorting.png added

attached a screen with the "wrong" sorting, as the example repository above might change...

#3 - 2009-07-01 14:06 - Ammler _

following patch "fixes" the sorting for mercurial, but of course, it doesn't work anymore for git and maybe other VCS,

http://dev.openttdcoop.org/hg_sorting.diff

#4 - 2009-07-01 14:10 - Ammler _

He, usually, I have edit rights for tickets. ;-)
I totally forgot to mention the used revision: it is trunk r2778

#5 - 2010-03-07 12:58 - Toshi MARUYAMA

- File redmine-sort-by-date.png added

- File redmine-sort-by-revno.png added

- % Done changed from 0 to 90

I fix this problem at #4455 follwing patch.

http://www.redmine.org/issues/4455#note-56

#6 - 2010-03-28 14:03 - Yuya Nishihara

It seems we can simply use ORDER BY id. At least, both Subversion and Mercurial insert changesets from earliest.

http://bitbucket.org/yuja/redmine-mq/src/tip/sort-changesets-by-id.diff

#7 - 2010-04-21 14:39 - Yuya Nishihara

Yuya Nishihara wrote:

It seems we can simply use ORDER BY id. At least, both Subversion and Mercurial insert changesets from earliest.

 No! It breaks git backend (#5357.) The patch needs updated to take effect only for Mercurial.

#8 - 2010-10-08 12:27 - Toshi MARUYAMA

- File hg-order-before.png added

- File hg-order-after.png added

- % Done changed from 90 to 100

These are test repository images of hg-changeset-order.patch at http://www.redmine.org/issues/4455#note-144

This patch take effect only for Mercurial.

Before patch applied

 hg-order-before.png 

After patch applied

 hg-order-after.png 

#9 - 2011-01-02 06:43 - Toshi MARUYAMA

- Assignee set to Toshi MARUYAMA

- Target version set to 1.1.0

#10 - 2011-01-02 07:15 - Toshi MARUYAMA

- Status changed from New to Closed

- Resolution set to Fixed

Fixed in svn trunk by r4611 and 1.1 by r4612.

Files

redmine_hg_sorting.png 22 KB 2009-07-01 Ammler _
